VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CService"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'************************************************************************************
'*
'*  Klassenname:    CService
'*  Beschreibung:   dient zum Administrieren und Erstellen von Services unter WinNT4 und hher
'*
'*  Autoren:        Kai Liebenau, Achim Neubauer (c)2004, 2005
'*
'*  erstellt fr:   Active VB als Erneuerung der Serviceklasse Kat 114
'*                  Erweiterrung um Funktionalitten fr Windows 2000 und hher,
'*                  also Failactions und Description
'*
'*  Version:        V 1.0
'*
'*
'*  todo:           ServiceSecurity?
'*                  AdjustTocken(SE_SHUTDOWN_NAME)
'*
'*
'*
'************************************************************************************

Option Explicit

Public Enum SC_ACTION_FLAG
    SC_ACTION_NONE = 0
    SC_ACTION_RESTART = 1
    SC_ACTION_REBOOT = 2
    SC_ACTION_RUN_COMMAND = 3
End Enum



Public Enum enumServiceActivityState
    SERVICE_ACTIVE = 1
    SERVICE_INACTIVE = 2
    SERVICE_STATE_ALL = 3
End Enum

Public Enum enumServiceStartType
    SERVICE_BOOT_START = 0
    SERVICE_AUTO_START = 2
    SERVICE_DEMAND_START = 3
    SERVICE_DISABLED = 4
End Enum

Public Enum enumServiceState
    SERVICE_UNKNOW = 0
    SERVICE_STOPPED = 1
    SERVICE_START_PENDING = 2
    SERVICE_STOP_PENDING = 3
    SERVICE_RUNNING = 4
    SERVICE_CONTINUE_PENDING = 5
    SERVICE_PAUSE_PENDING = 6
    SERVICE_PAUSED = 7
End Enum

Public Enum enumServiceTypes
    SERVICE_KERNEL_DRIVER = &H1
    SERVICE_FILE_SYSTEM_DRIVER = &H2
    
    SERVICE_TYPE_OWN_PROCESS = &H10&
    SERVICE_TYPE_SHARE_PROZESS = &H20&
    SERVICE_TYPE_INTERAKTIV = &H100&
End Enum

Public Enum enumErrorControl
    SERVICE_ERROR_IGNORE = 0
    SERVICE_ERROR_NORMAL = 1
    SERVICE_ERROR_SEVERE = 2
    SERVICE_ERROR_CRITICAL = 3
End Enum

Public Enum enumServiceAccept
    SERVICE_ACCEPT_STOP = &H1
    SERVICE_ACCEPT_SHUTDOWN = &H4
    SERVICE_ACCEPT_PAUSE_CONTINUE = &H2
    [SERVICE_ACCEPT_PARAMCHANGE] = &H8
    [SERVICE_ACCEPT_NETBINDCHANGE] = &H10
    [SERVICE_ACCEPT_HARDWAREPROFILECHANGE] = &H20
    [SERVICE_ACCEPT_POWEREVENT] = &H40
End Enum

Private Type SC_Action
    SC_Action As SC_ACTION_FLAG
    Delay As Long
End Type

Private Type SERVICE_FAILURE_ACTIONS
    dwResetPeriod As Long
    lpRebootMsg As Long
    lpCommand As Long
    cActions As Long
    dwReserved As Long                  'Wichtig fr VB und beinhaltet den Pointer auf lpsaActions(0) !!!
    lpsaActions(0 To 2) As SC_Action
End Type

'Typ fr API_QueryServiceConfig
Private Type QUERY_SERVICE_CONFIG
    dwServiceType As Long
    dwStartType As Long
    dwErrorControl As Long
    lpBinaryPathName As Long
    lpLoadOrderGroup As Long
    dwTagId As Long
    lpDependencies As Long
    lpServiceStartName As Long
    lpDisplayName As Long
End Type

'Private Const ERROR_PATH_NOT_FOUND              As Long = 3&
'Private Const ERROR_ACCESS_DENIED               As Long = 5&
'Private Const ERROR_INVALID_HANDLE              As Long = 6&
'Private Const ERROR_INVALID_PARAMETER           As Long = 87&
'Private Const ERROR_INSUFFICIENT_BUFFER         As Long = 122&
'Private Const ERROR_INVALID_NAME                As Long = 123&
'Private Const ERROR_MORE_DATA                   As Long = 234&
'Private Const ERROR_DEPENDENT_SERVICES_RUNNING  As Long = 1051&
'Private Const ERROR_INVALID_SERVICE_CONTROL     As Long = 1052&
'Private Const ERROR_SERVICE_REQUEST_TIMEOUT     As Long = 1053&
'Private Const ERROR_SERVICE_NO_THREAD           As Long = 1054&
'Private Const ERROR_SERVICE_DATABASE_LOCKED     As Long = 1055&
'Private Const ERROR_SERVICE_ALREADY_RUNNING     As Long = 1056&
'Private Const ERROR_SERVICE_DISABLED            As Long = 1058&
'Private Const ERROR_SERVICE_DOES_NOT_EXIST      As Long = 1060&
'Private Const ERROR_SERVICE_CANNOT_ACCEPT_CTRL  As Long = 1061&
'Private Const ERROR_SERVICE_NOT_ACTIVE          As Long = 1062&
'Private Const ERROR_DATABASE_DOES_NOT_EXIST     As Long = 1065&
'Private Const ERROR_SERVICE_DEPENDENCY_FAIL     As Long = 1068&
'Private Const ERROR_SERVICE_LOGON_FAILED        As Long = 1069&
'Private Const ERROR_SERVICE_MARKED_FOR_DELETE   As Long = 1072&
'Private Const ERROR_SERVICE_DEPENDENCY_DELETED  As Long = 1075&
'Private Const ERROR_SHUTDOWN_IN_PROGRESS        As Long = 1115&


Private Const c_Class                           As String = "CService"

Public Enum FailActionIndex
    iFirst
    iSecond
    iThirt
End Enum

Public Enum enumServiceAction
    SartCtl
    StopCtl
    PauseCtl
    ContinueCtl
    DeleteCtl
End Enum

Public Enum CServiceErrorConstants
    KEYNAME_MISSING = vbObjectError + 1
    INVALID_SCM_HANDLE = vbObjectError + 2
    SERVICE_WAS_NOT_CREATED = vbObjectError + 3
    NO_CREATETABLE_SERVICE = vbObjectError + 4
    INVALID_SERVICECONTROL = vbObjectError + 5
End Enum

Public Enum Handle
    [_]
End Enum

'Servicebuffer
Private m_KeyName                   As String
Private m_KeyNameNew                As String
Private m_BinaryPathName            As String
Private m_ControlsAccepted          As Long
Private m_SC2Actions                As Long 'is every 3
Private m_SC2FailAction(2)          As Long
Private m_SC2FailActionDelay(2)     As Long
Private m_SC2ResetPeriode           As Long
Private m_SC2AppendFailCounter      As Boolean
Private m_SC2CommandLineParameter   As String
Private m_SC2CommandLine            As String
Private m_SC2RebootMessage          As String
Private m_QueryService              As Boolean
Private m_ServiceType               As Long
Private m_ServiceStartType          As enumServiceStartType
Private m_ErrorControl              As Long
'Private m_StartType                 As Long
Private m_LoadOrderGroup            As String
Private m_TagId                     As Long
Private m_Dependencies              As String
Private m_AccountName               As String
Private m_AccountPassword           As String
Private m_Init                      As Boolean
Private m_DisplayName               As String

Private m_API_OK                    As Boolean
Private m_API_Config2_OK            As Boolean
Private m_ServiceConfigLoaded       As Boolean
Private m_ServiceConfig2Loaded      As Boolean
Private m_CreateService             As Boolean
'MainServiceManagerHandle
Private m_SCM_Handle                As Long
'Private m_CSecurity                 As cSecurity

'-------------------------------------------------------------------------------
' Init Service
'-------------------------------------------------------------------------------
Friend Sub Init_(hSCManager As Long, KeyName As String, Optional IsNewService As Boolean = False)
Const c_Sub As String = "::Init"

    'Keyname prfen
    If (Len(KeyName) = 0) And IsNewService = False Then
        Err.Raise KEYNAME_MISSING, c_Class & c_Sub, "Der Parameter 'KeyName' ist leer."
        Exit Sub
    End If
    
    'SVM Handle prfen
    If (hSCManager = 0) Then
        Err.Raise INVALID_SCM_HANDLE, c_Class & c_Sub, "Der Parameter 'hSCManager' ist ungltig."
        Exit Sub
    End If
    
    m_CreateService = IsNewService
    m_KeyName = KeyName
    m_SCM_Handle = hSCManager
    m_Init = True
End Sub
Private Function ConvertStateToStringState(lState As enumServiceState) As String
Select Case lState
    Case enumServiceState.SERVICE_CONTINUE_PENDING
        ConvertStateToStringState = "wird Fortgesetzt"
    Case enumServiceState.SERVICE_PAUSE_PENDING
        ConvertStateToStringState = "wird angehalten"
    Case enumServiceState.SERVICE_PAUSED
        ConvertStateToStringState = "angehalten"
    Case enumServiceState.SERVICE_RUNNING
        ConvertStateToStringState = "gestartet"
    Case enumServiceState.SERVICE_START_PENDING
        ConvertStateToStringState = "wird gestartet"
    Case enumServiceState.SERVICE_STOP_PENDING
        ConvertStateToStringState = "wird beendet"
    Case enumServiceState.SERVICE_STOPPED
        ConvertStateToStringState = "beendet"
    Case enumServiceState.SERVICE_UNKNOW
        ConvertStateToStringState = "unbekannt"
End Select
End Function
'-------------------------------------------------------------------------------
' Propertys
'-------------------------------------------------------------------------------
Public Property Get CurrentStateString() As String
CurrentStateString = ConvertStateToStringState(CurrentState)
End Property

Public Property Get CurrentState() As enumServiceState
CurrentState = GetCurrentState
End Property
Private Function GetCurrentState() As enumServiceState
Dim result As Long
Dim hService As Handle
Dim Status As SERVICE_STATUS
Const c_Property As String = "::GetCurrentState"

If m_API_OK Then
    
    If m_CreateService Then
        RaiseError c_Property, SERVICE_WAS_NOT_CREATED, "Dieser Service ist noch nicht erstellt!"
        Exit Function
    End If
    
    If m_SCM_Handle = 0 Then
        Call RaiseError(c_Property, INVALID_SCM_HANDLE, "Das ServiceManagerHandle ist ungltig.")
        Exit Function
    End If
    
    'Keyname prfen
    If (Len(m_KeyName) = 0) Then
        Call RaiseError(c_Property, KEYNAME_MISSING, "Der Parameter 'KeyName' ist nicht definiert.")
        Exit Function
    End If
    'Servicestatus abfragen
        
    hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_QUERY_STATUS)
    
    If (hService = 0) Then
        Call RaiseError(c_Property & ":API_OpenService")
        Exit Function
    End If
    
    result = API_QueryServiceStatus(hService, Status)
    
    If (result = 0) Then
        Call RaiseError(c_Property & ":API_QueryServiceStatus")
        Exit Function
    End If
    
    Call API_CloseServiceHandle(hService)
    
    GetCurrentState = Status.dwCurrentState
    m_ControlsAccepted = Status.dwControlsAccepted
Else
    Call RaiseError(c_Property, vbObjectError, "API ist nicht auffindbar")
End If
End Function
Public Function ServiceControl(ByVal eControl As enumServiceAction, Optional sStartArgV As String, Optional lStartArgC As Long) As Boolean
Dim uServiceState As SERVICE_STATUS

Select Case eControl
    Case enumServiceAction.SartCtl
        ServiceControl = StartService(sStartArgV, lStartArgC)
    Case enumServiceAction.StopCtl
        ServiceControl = ServiceControl_Int(uServiceState, SERVICE_CONTROL_STOP)
    Case enumServiceAction.PauseCtl
        ServiceControl = ServiceControl_Int(uServiceState, SERVICE_CONTROL_PAUSE)
    Case enumServiceAction.ContinueCtl
        ServiceControl = ServiceControl_Int(uServiceState, SERVICE_CONTROL_CONTINUE)
    Case enumServiceAction.DeleteCtl
        'coming soon
    Case Else
        RaiseError "ServiceControl", INVALID_SERVICECONTROL, "unbekannter Controlcode!"
End Select
End Function
Private Function StartService(Optional sStartArgV As String, Optional lStartArgC As Long) As Boolean
Const cFunction As String = "::StartService"
Dim hService    As Handle
Dim lAPIError   As Long

If m_API_OK Then
    If m_CreateService Then
        RaiseError cFunction, SERVICE_WAS_NOT_CREATED, "Dieser Service ist noch nicht erstellt!"
        Exit Function
    End If
    
    If m_SCM_Handle = 0 Then
        Call RaiseError(cFunction, INVALID_SCM_HANDLE, "Das ServiceManagerHandle ist ungltig.")
        Exit Function
    End If
    
    'Keyname prfen
    If (Len(m_KeyName) = 0) Then
        Call RaiseError(cFunction, KEYNAME_MISSING, "Der Parameter 'KeyName' ist nicht definiert.")
        Exit Function
    End If
    'Service ffnen
    hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_START Or SERVICE_QUERY_STATUS)
    If (hService) Then
        'Service starten
        If CBool(API_StartService(hService, 0, ByVal 0)) = False Then
            'wird auch ausgelst, wenn der Dienst schon luft
            lAPIError = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call RaiseError(cFunction, lAPIError)
        Else
            Debug.Print Err.LastDllError
            StartService = CheckState(hService, SERVICE_RUNNING, True)
        End If
        Call API_CloseServiceHandle(hService)
    Else
        Call RaiseError(cFunction)
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function
Private Function ServiceControl_Int(udtStatusInfo As SERVICE_STATUS, Optional lControl As enum_Service_Control = SERVICE_CONTROL_STOP) As Boolean
Const cFunction     As String = "::StopService"
Dim hService        As Handle
'Dim udtStatusInfo   As SERVICE_STATUS
Dim lAPIError       As Long

If m_API_OK Then
    If m_CreateService Then
        RaiseError cFunction, SERVICE_WAS_NOT_CREATED, "Dieser Service ist noch nicht erstellt!"
        Exit Function
    End If
    
    If m_SCM_Handle = 0 Then
        Call RaiseError(cFunction, INVALID_SCM_HANDLE, "Das ServiceManagerHandle ist ungltig.")
        Exit Function
    End If
    
    'Keyname prfen
    If (Len(m_KeyName) = 0) Then
        Call RaiseError(cFunction, KEYNAME_MISSING, "Der Parameter 'KeyName' ist nicht definiert.")
        Exit Function
    End If
    'Service ffnen
    hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_QUERY_STATUS Or SERVICE_STOP Or SERVICE_PAUSE_CONTINUE)
    
    If (hService) Then
        'Service starten
        If API_ControlService(hService, lControl, udtStatusInfo) = 0 Then
            'wird auch ausgelst, wenn der Dienst schon gestopt ist
            lAPIError = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call RaiseError(cFunction, lAPIError)
        Else
            
            If lControl = SERVICE_CONTROL_STOP Then
                ServiceControl_Int = CheckState(hService, SERVICE_STOPPED, True)
            ElseIf lControl = SERVICE_CONTROL_PAUSE Then
                ServiceControl_Int = CheckState(hService, SERVICE_PAUSED, True)
            ElseIf lControl = SERVICE_CONTROL_CONTINUE Then
                ServiceControl_Int = CheckState(hService, SERVICE_RUNNING, True)
            Else
                ServiceControl_Int = False
            End If
        End If
        Call API_CloseServiceHandle(hService)
    Else
        Call RaiseError(cFunction)
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function

Private Function CheckState(hService As Long, lState As enumServiceState, Optional bWait As Boolean = False) As Boolean
Dim dTime           As Date
Dim lWait           As Long
Dim uServiceState   As SERVICE_STATUS
Dim sErrDsc         As String
Dim rv              As Long

dTime = Now
Do
    Call Sleep(250)
    rv = API_QueryServiceStatus(hService, uServiceState)
    'Debug.Print "dwWaitHint: "; uServiceState.dwWaitHint
    If uServiceState.dwWin32ExitCode > 0 Then 'only 1066 ??
        Call API_CloseServiceHandle(hService)
        'If uServiceState.dwCurrentState = lState Then CheckState = True
        If uServiceState.dwWin32ExitCode = 1066 Then
            If uServiceState.dwServiceSpecificExitCode > 0 Then _
                sErrDsc = PrintMSG(uServiceState.dwServiceSpecificExitCode)
            If Len(sErrDsc) Then
                RaiseError "ControlService", _
                           uServiceState.dwServiceSpecificExitCode, _
                           sErrDsc
            Else
                RaiseError "ControlService", _
                           1066, _
                           Replace$(ERROR_SERVICE_SPECIFIC, "%DISPLAYNAME%", Me.DisplayName) & _
                           uServiceState.dwServiceSpecificExitCode
            End If
        Else
            RaiseError "ControlService", _
                       uServiceState.dwWin32ExitCode, _
                       PrintMSG(uServiceState.dwWin32ExitCode)
        End If
        Exit Do
    End If
    'Debug.Print uServiceState.dwCurrentState, lState, uServiceState.dwWaitHint
    If uServiceState.dwCurrentState = lState Then
        CheckState = True
        Exit Do
    End If
    If uServiceState.dwWaitHint > 0 Then
        'Dienstspezifische Wartezeit bernehmen
        lWait = uServiceState.dwWaitHint / 1000
    Else
        '6 sek Wartezeit eintragen
        lWait = 6
    End If
    Call Sleep(250)
Loop While bWait = True And DateDiff("s", dTime, Now) < lWait
End Function

Public Property Get KeyName() As String
    KeyName = m_KeyName
End Property
Public Property Let KeyName(NewValue As String)
If m_CreateService Then
    m_KeyNameNew = NewValue
Else
    Call RaiseError("KeyName", vbObjectError, "Zuweisung an schreibgeschtzte Eigenschaft nicht mglich!")
End If
End Property
'------------------------------------------------------------------------------
' API_QueryServiceConfig
'-------------------------------------------------------------------------------
Private Function CheckServiceLoaded(sPropertyName As String) As Boolean
CheckServiceLoaded = True

If m_Init Then
    Call VBQueryServiceConfig
Else
    Call RaiseError(sPropertyName, 0, "Class not Initialisiert")
    CheckServiceLoaded = False
End If

End Function

Public Property Get ServiceType() As enumServiceTypes
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("ServiceType") = False Then Exit Property
    ServiceType = m_ServiceType
End Property
Public Property Let ServiceType(NewType As enumServiceTypes)
    m_ServiceType = NewType
End Property
Public Property Get ServiceStartTypeString() As String
Select Case Me.ServiceStartType
    Case enumServiceStartType.SERVICE_AUTO_START
        ServiceStartTypeString = "Automatisch"
    Case enumServiceStartType.SERVICE_BOOT_START
        ServiceStartTypeString = "Systemstart"
    Case enumServiceStartType.SERVICE_DEMAND_START
        ServiceStartTypeString = "Manuell"
    Case enumServiceStartType.SERVICE_DISABLED
        ServiceStartTypeString = "Deaktiviert"
End Select
End Property
Public Property Get ServiceStartType() As enumServiceStartType
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("ServiceStartType") = False Then Exit Property
    ServiceStartType = m_ServiceStartType
End Property
Public Property Let ServiceStartType(NewStartType As enumServiceStartType)
    m_ServiceStartType = NewStartType
End Property
Public Property Get ErrorControl() As enumErrorControl
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("ErrorControl") = False Then Exit Property
    ErrorControl = m_ErrorControl
End Property
Public Property Let ErrorControl(NewErrorControl As enumErrorControl)
    m_ErrorControl = NewErrorControl
End Property
Public Property Get BinaryPathName() As String
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("BinaryPathName") = False Then Exit Property
    BinaryPathName = m_BinaryPathName
End Property
Public Property Let BinaryPathName(NewBinaryPathName As String)
    m_BinaryPathName = NewBinaryPathName
End Property
Public Property Get LoadOrderGroup() As String
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("LoadOrderGroup") = False Then Exit Property
    LoadOrderGroup = m_LoadOrderGroup
End Property
Public Property Let LoadOrderGroup(NewLoadOrderGroup As String)
    m_LoadOrderGroup = NewLoadOrderGroup
End Property
Public Property Get TagId() As Long
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("TagId") = False Then Exit Property
    TagId = m_TagId
End Property
'Public Property Let TagId(NewTagId As Long)
'    m_TagId = NewTagId
'End Property
Public Property Get DependenciesServices() As cServiceEnum
Set DependenciesServices = ConvertToServiceEnum(Me.Dependencies)
End Property
Public Property Get Dependencies() As String
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("Dependencies") = False Then Exit Property
    Dependencies = m_Dependencies
End Property
Public Property Let Dependencies(NewDependencies As String)
    m_Dependencies = NewDependencies
End Property
Public Property Get DependentSerivces() As cServiceEnum
Const sFunction As String = "::DependentSerivces"
Dim Services() As ENUM_SERVICE_STATUS
Dim bBuffer() As Byte
Dim lBytesneeded As Long
Dim lResult As Long
Dim lServices As Long
Dim sServices As String
Dim hService As Long

hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_ENUMERATE_DEPENDENTS)

If (hService) Then
    Call API_EnumDependentServices(hService, SERVICE_STATE_ALL, ByVal 0, 0, lBytesneeded, lResult)
    If lBytesneeded > 0 Then
        ReDim bBuffer(lBytesneeded)
        If CBool(API_EnumDependentServices(hService, SERVICE_STATE_ALL, bBuffer(0), UBound(bBuffer), lBytesneeded, lResult)) Then
            ReDim Services(lResult)
            API_CopyMemory Services(0), bBuffer(0), lResult * LenB(Services(0))
            For lServices = 0 To lResult - 1
                sServices = sServices & PtrStrA(Services(lServices).lpServiceName) & ";"
            Next
            Set DependentSerivces = ConvertToServiceEnum(Left$(sServices, Len(sServices) - 1))
        Else
            lResult = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call RaiseError(sFunction, lResult)
        End If 'If CBool(API_EnumDependentServices(hServi
    Else
        lResult = Err.LastDllError
        If lResult > 0 And lResult <> 997 Then
            Call API_CloseServiceHandle(hService)
            Call RaiseError(sFunction, lResult)
        End If 'If lResult Then
    End If 'If lBytesneeded > 0 Then
    Call API_CloseServiceHandle(hService)
Else
    Call RaiseError(sFunction)
End If
End Property
Public Property Get AccountName() As String
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("AccountName") = False Then Exit Property
    AccountName = m_AccountName
End Property
Public Property Let AccountName(NewAccountName As String)
    m_AccountName = NewAccountName
End Property
Public Property Let AccountPassword(NewPassword As String)
m_AccountPassword = NewPassword
End Property
Public Property Get DisplayName() As String
    If m_ServiceConfigLoaded = False Then _
        If CheckServiceLoaded("DisplayName") = False Then Exit Property
    DisplayName = m_DisplayName
End Property
Public Property Let DisplayName(NewDisplayName As String)
    m_DisplayName = NewDisplayName
End Property

Public Property Get AcceptServiceControl(ByVal lFlag As enumServiceAccept) As Boolean
If m_ControlsAccepted = 0 Then Call GetCurrentState
AcceptServiceControl = (m_ControlsAccepted And lFlag)
End Property

Public Function LoadServiceConfig() As Boolean
Const cFunction As String = "::LoadServiceConfig"

If m_API_OK Then
    'API gefunden und kann verwendet werden
    If m_CreateService Then
        Call RaiseError(cFunction, SERVICE_WAS_NOT_CREATED, "Service wurde noch nicht erstellt")
    Else
        LoadServiceConfig = VBQueryServiceConfig()
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function
Public Function SaveServiceConfig() As Boolean
Attribute SaveServiceConfig.VB_Description = "Speichert die geladene Serviceconfig ab und stellt damit den Service ein."
Const cFunction As String = "::SaveServiceConfig"

If m_API_OK Then
    'API gefunden und kann verwendet werden
    If m_CreateService Then
        Call RaiseError(cFunction, SERVICE_WAS_NOT_CREATED, "Service wurde noch nicht erstellt")
    Else
        SaveServiceConfig = VBChangeServiceConfig
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function

Private Function VBQueryServiceConfig() As Boolean
Const cFunction     As String = "::VBQueryServiceConfig"
Dim hService        As Handle
Dim Ret             As Long
Dim lBytesNeed      As Long
Dim lAPIError       As Long
Dim barrBuffer()    As Byte
Dim ServiceConfig   As QUERY_SERVICE_CONFIG

If m_API_OK Then
    'API gefunden und kann verwendet werden
    hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_QUERY_CONFIG)
    If (hService) Then
        Call API_QueryServiceConfig(hService, ByVal 0, 0, lBytesNeed)
        ReDim barrBuffer(0 To lBytesNeed)
        If API_QueryServiceConfig(hService, barrBuffer(0), UBound(barrBuffer) + 1, lBytesNeed) <> 0 Then
            Call API_CopyMemory(ServiceConfig, barrBuffer(0), Len(ServiceConfig))
            m_BinaryPathName = PtrStrW(ServiceConfig.lpBinaryPathName)
            m_Dependencies = EleminateGroups(PtrArrayStrW(ServiceConfig.lpDependencies))
            m_DisplayName = PtrStrW(ServiceConfig.lpDisplayName)
            m_LoadOrderGroup = PtrStrW(ServiceConfig.lpLoadOrderGroup)
            m_AccountName = PtrStrW(ServiceConfig.lpServiceStartName)
            m_ErrorControl = ServiceConfig.dwErrorControl
            m_ServiceType = ServiceConfig.dwServiceType
            m_ServiceStartType = ServiceConfig.dwStartType
            m_TagId = ServiceConfig.dwTagId
            
            Call API_CloseServiceHandle(hService)
            m_ServiceConfigLoaded = True
            VBQueryServiceConfig = True
        Else
            lAPIError = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call RaiseError(cFunction & ":QueryServiceConfig", lAPIError)
        End If
    Else
        Call RaiseError(cFunction & ":OpenService")
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function
Private Function VBChangeServiceConfig() As Boolean
Const cFunction     As String = "::VBChangeServiceConfig"
Dim Ret             As Long
Dim hService        As Long
Dim hSCMLock        As Handle
Dim lAPIError       As Long
Dim sDependencies   As String

If m_API_OK Then
    'API gefunden und kann verwendet werden
    hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_CHANGE_CONFIG)
    If (hService) Then
        'Die Database sollte gelocked sein, wenn man die Seviceconfig ndert !
        hSCMLock = API_LockServiceDatabase(m_SCM_Handle)
        If (hSCMLock) Then
            'Password darf niemals ein VBNullString sein !!!
            If Len(m_AccountPassword) = 0 Then m_AccountPassword = ""
            'Accountname muss angegeben werden, mindestens der Account LocalSystem !
            If Len(m_AccountName) = 0 Then m_AccountName = "LocalSystem"
            'Bei anderem User als LocalSystem wird keine Interaktive Beziehung zum Desktop erlaubt
            'Servicetypes berichtigen
            If LCase$(m_AccountName) <> "localsystem" Then _
                m_ServiceType = m_ServiceType And Not (SERVICE_TYPE_INTERAKTIV)
            'Den Delimiter sicherstellen
            m_Dependencies = Replace$(m_Dependencies, vbCrLf, ";")
            m_Dependencies = Replace$(m_Dependencies, ",", ";")
            
            sDependencies = Replace$(m_Dependencies, ";", vbNullChar) & vbNullChar
            'ServiceConfig speichern
            Ret = API_ChangeServiceConfig(hService, _
                                      m_ServiceType, _
                                      m_ServiceStartType, _
                                      m_ErrorControl, _
                                      m_BinaryPathName, _
                                      m_LoadOrderGroup, _
                                      ByVal 0, _
                                      sDependencies, _
                                      m_AccountName, _
                                      m_AccountPassword, _
                                      m_DisplayName)
                                      
            lAPIError = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call API_UnlockServiceDatabase(hSCMLock)
            If (Ret = 0) Then Call RaiseError(cFunction & ":API_ChangeServiceConfig", lAPIError)
            m_ServiceConfigLoaded = True
            VBChangeServiceConfig = True
        Else
            lAPIError = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call RaiseError(cFunction & ":LockServiceDatabase", lAPIError)
        End If
    Else
        Call RaiseError(cFunction & ":OpenService")
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function
Public Function CreateService() As Boolean
Const cFunction As String = "::CreateService"

'Prfung aller wichtigen Parameter
If m_API_OK = False Then _
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
If m_CreateService = False Then _
    Call RaiseError(cFunction, NO_CREATETABLE_SERVICE, "Kein Service zum erstellen vorhanden!")
If Len(m_BinaryPathName) = 0 Then _
    Call RaiseError(cFunction, 87, "Kein Binary angegeben!")
If Len(m_KeyNameNew) = 0 Then _
    Call RaiseError(cFunction, 87, "Kein Keyname angegeben!")
If Len(m_DisplayName) = 0 Then _
    Call RaiseError(cFunction, 87, "Kein Displayname angegeben!")
If m_ServiceType = 0 Then _
    Call RaiseError(cFunction, 87, "Kein Servicetype angegeben!")
If m_ServiceStartType = 0 Then _
    Call RaiseError(cFunction, 87, "Kein Starttype angegeben!")
'wenn alle Parameter stimmten, dann Service erstellen
CreateService = VBCreateService
End Function
Private Function VBCreateService() As Boolean
Const cFunction     As String = "::VBChangeServiceConfig"
Dim Ret             As Long
Dim hService        As Long
Dim hSCMLock        As Handle
Dim lAPIError       As Long
Dim sDependencies   As String

If m_API_OK Then
    'API gefunden und kann verwendet werden
    hSCMLock = API_LockServiceDatabase(m_SCM_Handle)
    If (hSCMLock) Then
        'Password darf niemals ein VBNullString sein !!!
        If Len(m_AccountPassword) = 0 Then m_AccountPassword = ""
        'Accountname muss angegeben werden, mindestens der Account LocalSystem !
        If Len(m_AccountName) = 0 Then m_AccountName = "LocalSystem"
        'Bei anderem User als LocalSystem wird keine Interaktive Beziehung zum Desktop erlaubt
        'Servicetypes berichtigen
        If LCase$(m_AccountName) <> "localsystem" Then _
            m_ServiceType = m_ServiceType And Not (SERVICE_TYPE_INTERAKTIV)
        'Den Delimiter sicherstellen
        m_Dependencies = Replace$(m_Dependencies, vbCrLf, vbNullChar)
        m_Dependencies = Replace$(m_Dependencies, ",", vbNullChar) & vbNullChar
        
        'Service erstellen
        hService = API_CreateService(m_SCM_Handle, _
                                   m_KeyNameNew, _
                                   m_DisplayName, _
                                   &H1F0FF, _
                                   m_ServiceType, _
                                   m_ServiceStartType, _
                                   m_ErrorControl, _
                                   m_BinaryPathName, _
                                   m_LoadOrderGroup, _
                                   ByVal 0, _
                                   sDependencies, _
                                   m_AccountName, _
                                   m_AccountPassword)
                                  
        lAPIError = Err.LastDllError
        Err.Clear
        Call API_CloseServiceHandle(hService)
        Call API_UnlockServiceDatabase(hSCMLock)
        If (hService = 0) Then
            Call RaiseError(cFunction & ":CreateService", lAPIError)
        Else
            m_CreateService = False
            VBCreateService = True
            m_ServiceConfigLoaded = True
            m_KeyName = m_KeyNameNew
            m_KeyNameNew = vbNullString
        End If
    Else
        lAPIError = Err.LastDllError
        Call API_CloseServiceHandle(hService)
        Call RaiseError(cFunction & ":LockServiceDatabase", lAPIError)
    End If
            
Else
    Call RaiseError(cFunction, vbObjectError, "API ist nicht auffindbar")
End If
End Function
'------------------------------------------------------------------------------
' API_QueryServiceConfig2 Sektion
'-------------------------------------------------------------------------------
Public Property Get Description() As String
Const cFunction As String = "::Description:"
Dim res             As Long
Dim hService        As Handle
Dim lBufferSize     As Long
Dim Buffer()        As Byte
Dim lAPIError       As Long
Dim lPointer        As Long

If m_API_Config2_OK Then
    If m_CreateService = False Then
        hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_QUERY_CONFIG)
        If (hService = 0) Then
            Call RaiseError(cFunction & "OpenService")
        Else
            Err.Clear
            
            'Erster Aufruf, um die Buffergre zu ermitteln
            res = API_QueryServiceConfig2(hService, SERVICE_CONFIG_DESCRIPTION, ByVal 0, 0, lBufferSize)
            
            'Buffer dimensionieren
            ReDim Buffer(0 To lBufferSize)
        
            'Zweiter Aufruf um die Daten in den Buffer zu holen
            If API_QueryServiceConfig2(hService, SERVICE_CONFIG_DESCRIPTION, Buffer(0), lBufferSize, lBufferSize) = 0 Then
                lAPIError = Err.LastDllError
                Call API_CloseServiceHandle(hService)
                Call RaiseError(cFunction & "QueryServiceConfig2", lAPIError)
            Else
                'Stringpointer ermitteln
                API_CopyMemory lPointer, Buffer(0), 4
                If lPointer Then Description = PtrStrW(lPointer)
            End If 'If API_QueryServiceConfig2(..) = 0 Then
        End If 'If (hService = 0) Then
        'Handle zum SCM schlieen
        If (hService <> 0) Then Call API_CloseServiceHandle(hService)
    Else
        'eine Description kann erst nach dem Erstellen gelesen werden!
        Call RaiseError(cFunction, SERVICE_WAS_NOT_CREATED, "Service wurde noch nicht erstellt")
    End If 'If m_CreateService = False Then
Else
    Call RaiseError(cFunction, vbObjectError, "Kein Win2k oder hher gefunden!")
End If
End Property
Public Property Let Description(NewDescription As String)
Const cFunction As String = "::Description:"
Dim hService        As Handle
Dim hSCMLock        As Handle
Dim sDelMsg         As String
Dim lAPIError       As Long

If m_API_Config2_OK Then
    If m_CreateService = False Then
        'die Datenbank vom ServiceControlManager locken
        hSCMLock = API_LockServiceDatabase(m_SCM_Handle)
        If hSCMLock = 0 Then
            Call RaiseError(cFunction & "LockServiceDatabase")
        Else
            'Service ffnen
            hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_ALL_ACCESS)
            If hService = 0 Then
                'API fehler merken
                lAPIError = Err.LastDllError
                'SCM Lock lsen, ganz wichtig!
                Call API_UnlockServiceDatabase(hSCMLock)
                'Error abfeuern
                Call RaiseError(cFunction & "OpenService", lAPIError)
            Else
                'Prfen ob die Description gelscht werden soll
                If (Len(NewDescription) = 0) Then
                    sDelMsg = "" 'lschen
                Else
                    sDelMsg = NewDescription 'neu setzen
                End If
                'Service ndern
                If API_ChangeServiceConfig2(hService, SERVICE_CONFIG_DESCRIPTION, StrPtr(sDelMsg)) = 0 Then
                    'API Fehler merken
                    lAPIError = Err.LastDllError
                    'Servicehandle schlieen
                    Call API_CloseServiceHandle(hService): hService = 0
                    'SCM Lock aufheben!!
                    Call API_UnlockServiceDatabase(hSCMLock): hSCMLock = 0
                    'Fehler ausgeben.
                    Call RaiseError(cFunction & "ChangeServiceConfig2", lAPIError)
                End If 'If API_ChangeServiceConfig2(..) = 0 then
            End If 'If hService = 0 Then
        End If 'If hSCMLock = 0 Then
        
        'Handle zum SCM schlieen
        If (hSCMLock <> 0) Then Call API_UnlockServiceDatabase(hSCMLock)
        If (hService <> 0) Then Call API_CloseServiceHandle(hService)
    Else
        'eine Description kann erst nach dem Erstellen gesetzt werden!
        Call RaiseError(cFunction, SERVICE_WAS_NOT_CREATED, "Service wurde noch nicht erstellt")
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "Kein Win2k oder hher gefunden!")
End If
End Property

'Reboot Message die angezeigt wird
Property Get RebootMessage() As String
RebootMessage = m_SC2RebootMessage
End Property

Property Let RebootMessage(ByVal NewVal As String)
m_SC2RebootMessage = NewVal
End Property
' Commandline Parameter welche gestartet werden soll
Property Get CommandLine() As String
CommandLine = m_SC2CommandLine
End Property
Property Let CommandLine(ByVal NewVal As String)
m_SC2CommandLine = NewVal
End Property
Property Get CommandLineParameter() As String
CommandLineParameter = m_SC2CommandLineParameter
End Property
Property Let CommandLineParameter(ByVal NewVal As String)
m_SC2CommandLineParameter = NewVal
End Property
Property Get AppendFailCounter() As Boolean
AppendFailCounter = m_SC2AppendFailCounter
End Property
Property Let AppendFailCounter(ByVal NewVal As Boolean)
m_SC2AppendFailCounter = NewVal
End Property
'wann der Fehlerzhler wieder auf 0 gesetzt wird
Property Get ResetPeriode() As Long
ResetPeriode = m_SC2ResetPeriode
End Property
Property Let ResetPeriode(ByVal NewVal As Long)
m_SC2ResetPeriode = NewVal
End Property
'FailActions
Property Get FailAction(ByVal Index As FailActionIndex) As SC_ACTION_FLAG
FailAction = m_SC2FailAction(Index)
End Property
Property Let FailAction(ByVal Index As FailActionIndex, ByVal NewVal As SC_ACTION_FLAG)
m_SC2FailAction(Index) = NewVal
End Property
Property Get FailActionDelay(ByVal Index As FailActionIndex) As Long
FailActionDelay = m_SC2FailActionDelay(Index)
End Property
Property Let FailActionDelay(ByVal Index As FailActionIndex, ByVal NewVal As Long)
m_SC2FailActionDelay(Index) = NewVal
End Property

Public Function LoadServiceConfig2() As Boolean
Const cFunction As String = "::LoadServiceConfig2"

If m_API_Config2_OK Then
    'API gefunden und kann verwendet werden
    If m_CreateService Then
        Call RaiseError(cFunction, SERVICE_WAS_NOT_CREATED, "Service wurde noch nicht erstellt")
    Else
        LoadServiceConfig2 = VBQueryServiceConfig2
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "Kein Windows 2000 oder hher gefunden!")
End If

End Function
Public Function SaveServiceConfig2() As Boolean
Const cFunction As String = "::SaveServiceConfig2"

If m_API_Config2_OK Then
    'API gefunden und kann verwendet werden
    If m_CreateService Then
        Call RaiseError(cFunction, SERVICE_WAS_NOT_CREATED, "Service wurde noch nicht erstellt")
    Else
        SaveServiceConfig2 = VBChangeServiceConfig2
    End If
Else
    Call RaiseError(cFunction, vbObjectError, "Kein Windows 2000 oder hher gefunden!")
End If
End Function

Private Function VBQueryServiceConfig2() As Boolean
Const cFunction As String = "::VBQueryServiceConfig2:"
Dim x               As Long
Dim res             As Long
Dim lEndAppLine     As Long
Dim hService        As Handle
Dim lBufferSize     As Long
Dim sCommandLine    As String
Dim ServiceAction   As SERVICE_FAILURE_ACTIONS
Dim Buffer()        As Byte
Dim lAPIError       As Long

If m_API_Config2_OK Then
    hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_QUERY_CONFIG)
    If (hService = 0) Then
        Call RaiseError(cFunction & "OpenService")
    Else
        Err.Clear
        
        'Erster Aufruf, um die Buffergre zu ermitteln
        res = API_QueryServiceConfig2(hService, SERVICE_CONFIG_FAILURE_ACTIONS, ByVal 0, 0, lBufferSize)
        
        'Buffer dimensionieren
        ReDim Buffer(0 To lBufferSize)
    
        'Zweiter Aufruf um die Daten in den Buffer zu holen
        If API_QueryServiceConfig2(hService, SERVICE_CONFIG_FAILURE_ACTIONS, Buffer(0), lBufferSize, lBufferSize) = 0 Then
            lAPIError = Err.LastDllError
            Call API_CloseServiceHandle(hService)
            Call RaiseError(cFunction & "QueryServiceConfig2", lAPIError)
        Else
            If lBufferSize >= LenB(ServiceAction) Then
                'Daten aus dem ByteArray in die VB Struktur bertragen
                API_CopyMemory ServiceAction, Buffer(0), LenB(ServiceAction)
                m_SC2Actions = ServiceAction.cActions
                m_SC2ResetPeriode = ServiceAction.dwResetPeriod / 86400 'in Tagen angeben
                sCommandLine = PtrStrW(ServiceAction.lpCommand)
                m_SC2RebootMessage = PtrStrW(ServiceAction.lpRebootMsg)
                'und jetzt noch jede einzelne Aktion in die VB Struktur bernehmen
                For x = 0 To 2
                    m_SC2FailActionDelay(x) = ServiceAction.lpsaActions(x).Delay / 60000 'Service_Fail_Action(x).Delay
                    m_SC2FailAction(x) = ServiceAction.lpsaActions(x).SC_Action ' Service_Fail_Action(x).SC_Action
                Next
            
                'Zerlegen von der Commandline
                'Failcounter angehngt?
                m_SC2AppendFailCounter = CBool(InStr(1, sCommandLine, SERVICE_FAIL_COUNTER, vbBinaryCompare))
                'FailCounter abschneiden
                sCommandLine = Replace$(sCommandLine, SERVICE_FAIL_COUNTER, vbNullString)
                'App to start
                If Left$(sCommandLine, 1) = """" Then 'Begint mit " ?
                    lEndAppLine = InStr(2, sCommandLine, """", vbBinaryCompare) '2. Zeichen " ermitteln
                Else
                    lEndAppLine = InStr(1, sCommandLine, BLANK_CHAR, vbBinaryCompare) 'Leerzeichen suchen
                    If lEndAppLine = 0 Then lEndAppLine = Len(sCommandLine) ' wenn keins gefunden, dann Len()
                End If
                m_SC2CommandLine = Trim$(Replace$(Left$(sCommandLine, lEndAppLine), """", vbNullString))
                'Benutzerdefinierter Parameterblock
                m_SC2CommandLineParameter = Trim$(Mid$(sCommandLine, lEndAppLine + 1))
                'Erfolg
                VBQueryServiceConfig2 = True
            End If 'If lBufferSize >= LenB(ServiceAction) Then
        End If 'If API_QueryServiceConfig2(..) = 0 Then
    End If 'If (hService = 0) Then
    'Handle zum SCM schlieen
    If (hService <> 0) Then Call API_CloseServiceHandle(hService)
Else
    Call RaiseError(cFunction, vbObjectError, "Kein Win2k oder hher gefunden!")
End If
End Function
Private Function VBChangeServiceConfig2() As Boolean
Const cFunction     As String = "::VBChangeServiceConfig2:"
Dim x               As Long
Dim hService        As Handle
Dim hSCMLock        As Handle
Dim sDelMsg         As String
Dim sCommandLine    As String
Dim ServiceAction   As SERVICE_FAILURE_ACTIONS
Dim lAPIError       As Long
Dim cShutDown       As cPrivilege
Dim bShutDown       As Boolean
Dim Ret             As Long

If m_API_Config2_OK Then
    'AdjustToken !!!
    
    'die Datenbank vom ServiceControlManager locken
    hSCMLock = API_LockServiceDatabase(m_SCM_Handle)
    If hSCMLock = 0 Then
        Call RaiseError(cFunction & "LockServiceDatabase")
    Else
        'Service ffnen
        hService = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_ALL_ACCESS)
        If hService = 0 Then
            lAPIError = Err.LastDllError
            Call API_UnlockServiceDatabase(hSCMLock)
            Call RaiseError(cFunction & "OpenService", lAPIError)
        Else
            'Failure_Actions in die API Struktur bertragen
            bShutDown = False
            Set cShutDown = New cPrivilege
            For x = 0 To 2
                ServiceAction.lpsaActions(x).SC_Action = m_SC2FailAction(x)
                If m_SC2FailAction(x) = SC_ACTION_REBOOT And bShutDown = False Then
                    Ret = cShutDown.IsPrivilegEnabled(SE_SHUTDOWN)
                    If Ret = 1 Then
                        bShutDown = True
                    ElseIf Ret = 0 Then
                        bShutDown = Not CBool(cShutDown.AdjustTokenPriv(SE_SHUTDOWN, True))
                    Else
                        'Error Nummer = Ret
                    End If
                End If
                ServiceAction.lpsaActions(x).Delay = m_SC2FailActionDelay(x) * 60000
            Next
            Set cShutDown = Nothing
            'folgender Eintrag ist sehr wichtig, er beinhaltet den Pointer auf die Actions Unterstrucktur
            'ohne diesen schlgt eine Servicenderung fehl. In C/C++ gibt es diesen Parameter nicht.
            ServiceAction.dwReserved = VarPtr(ServiceAction.lpsaActions(0))
            
            ServiceAction.cActions = 3 'sollte immer 3 sein
            
            'Deletestring initialisieren, dies ist wichtig da sonst der Stringpointer 0 ist
            sDelMsg = ""
            
            'Fehlerzhler zurcksetzen
            ServiceAction.dwResetPeriod = m_SC2ResetPeriode * 86400
            
            'wenn der vorhandene Eintag gelscht werden soll muss der Pointer
            'auf sDelMsg bergeben werden, wenn als Pointer eine 0 bergeben wird,
            'werden die Eintrge nicht verndert!!
            If Len(m_SC2CommandLine) <> 0 Then
                sCommandLine = """" & m_SC2CommandLine & """" & BLANK_CHAR & m_SC2CommandLineParameter & _
                    IIf(m_SC2AppendFailCounter, BLANK_CHAR & SERVICE_FAIL_COUNTER, vbNullString)
                ServiceAction.lpCommand = StrPtr(sCommandLine)
            Else
                ServiceAction.lpCommand = StrPtr(sDelMsg)
            End If
            'ReebootMsg setzen
            If Len(m_SC2RebootMessage) <> 0 Then
                ServiceAction.lpRebootMsg = StrPtr(m_SC2RebootMessage)
            Else
                ServiceAction.lpRebootMsg = StrPtr(sDelMsg)
            End If
            
            'Wenn eine Action als SC_ACTION_REBOOT ausgewhlt wurde, so muss das Privileg
            'SE_SHUTDOWN_NAME Enabled sein. Ansonsten wird der Vorgang mit dem Fehler 5 abgebrochen!
            'Service ndern
            If API_ChangeServiceConfig2(hService, SERVICE_CONFIG_FAILURE_ACTIONS, ServiceAction) = 0 Then
                lAPIError = Err.LastDllError
                Call API_CloseServiceHandle(hService)
                Call API_UnlockServiceDatabase(hSCMLock)
                Call RaiseError(cFunction & "ChangeServiceConfig2", lAPIError)
            Else
                VBChangeServiceConfig2 = True
            End If 'If API_ChangeServiceConfig2(..) = 0 then
        End If 'If hService = 0 Then
    End If 'If hSCMLock = 0 Then
    
    'Handle zum SCM schlieen
    If (hSCMLock <> 0) Then Call API_UnlockServiceDatabase(hSCMLock)
    If (hService <> 0) Then Call API_CloseServiceHandle(hService)
Else
    Call RaiseError(cFunction, vbObjectError, "Kein Win2k oder hher gefunden!")
End If
End Function

'ServiceSecurity
'Public Function GetSeviceSecurityInfo() As Long
'Dim rv As Long
'
'If m_CSecurity Is Nothing Then Set m_CSecurity = New cSecurity
'
'rv = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_ALL_ACCESS)
'm_CSecurity.GetSecurity rv
'API_CloseServiceHandle rv
'End Function
'Public Function SetServiceOwner(ByVal NewOwner) As Long
'Dim rv As Long
'
'If m_CSecurity Is Nothing Then Set m_CSecurity = New cSecurity
'
'rv = API_OpenService(m_SCM_Handle, m_KeyName, SERVICE_ALL_ACCESS)
'SetServiceOwner = m_CSecurity.SetOwner(NewOwner, rv)
'API_CloseServiceHandle rv
'End Function

Private Function PtrArrayStrA(ByVal lPointer As Long, Optional Seperator As String = ";") As String
Dim sTempStr As String
PtrArrayStrA = vbNullString
sTempStr = PtrStrA(lPointer) 'ersten String holen
Do While Len(sTempStr) > 0 'nur in die Schleife wenn auch ein String gefunden
    PtrArrayStrA = PtrArrayStrA & sTempStr & Seperator 'String anfgen
    lPointer = lPointer + Len(sTempStr) + 1 'neuen Pointer berechnen
    sTempStr = PtrStrA(lPointer) 'nchsten Sting holen
Loop
'Nur falls ein Returnstring da ist, dann letztes Zeichen abschneiden
If Len(PtrArrayStrA) > 0 Then _
    PtrArrayStrA = Left$(PtrArrayStrA, Len(PtrArrayStrA) - Len(Seperator))
End Function
Private Function PtrArrayStrW(ByVal lPointer As Long, Optional Seperator As String = ";") As String
Dim sTempStr As String
PtrArrayStrW = vbNullString
sTempStr = PtrStrW(lPointer) 'ersten String holen
Do While Len(sTempStr) > 0 'nur in die Schleife wenn auch ein String gefunden
    PtrArrayStrW = PtrArrayStrW & sTempStr & Seperator 'String anfgen
    lPointer = lPointer + LenB(sTempStr) + 2 'neuen Pointer berechnen
    sTempStr = PtrStrW(lPointer) 'nchsten Sting holen
Loop
'Nur falls ein Returnstring da ist, dann letztes Zeichen abschneiden
If Len(PtrArrayStrW) > 0 Then _
    PtrArrayStrW = Left$(PtrArrayStrW, Len(PtrArrayStrW) - Len(Seperator))
End Function
Private Function PtrStrA(ByVal lPointer As Long) As String
    'String initialisieren
   PtrStrA = String$(StrLenA(lPointer), vbNullChar)
    'String kopieren
   Call PtrToStrA(PtrStrA, lPointer)
End Function

Private Function PtrStrW(ByVal lPointer As Long) As String
    'String initialisieren
   PtrStrW = String$(StrLenW(lPointer), vbNullChar)
    'String kopieren
   Call PtrToStrW(StrPtr(PtrStrW), lPointer)
   'Call PtrToStrW(PtrStrW, lPointer)
End Function

'------------------------------------------------------------------------------
' Classinit
'-------------------------------------------------------------------------------
Private Sub Class_Initialize()
Dim hLib As Handle
Dim lProcAddr As Long

Const cFunction As String = "::Class_Initialize"

'Prfung auf vorhandensein der API DLL und auf W2k und hher
hLib = API_LoadLibrary("advapi32.dll")
If (hLib) Then
    'Lib konnte geladen werden
    lProcAddr = API_GetProcAddress(hLib, "QueryServiceConfigW")
    If (lProcAddr) Then
        'Prozedureinstieg wurde gefunden
        m_API_OK = True
        lProcAddr = API_GetProcAddress(hLib, "QueryServiceConfig2W")
        If (lProcAddr) Then m_API_Config2_OK = True 'W2k oder hher gefunden
    Else
        'Lib geladen, aber Prozedureinstieg nicht vorhanden
        Call RaiseError(cFunction)
    End If
    'Lib wieder freigeben
    Call API_FreeLibrary(hLib)
Else
    'API DLL nicht gefunden oder anderer Fehler
    Call RaiseError(cFunction)
End If
End Sub
Private Sub Class_Terminate()
'If Not (m_CSecurity Is Nothing) Then Set m_CSecurity = Nothing
End Sub

Private Function ConvertToServiceEnum(sServices As String) As cServiceEnum
Dim cTempService As CService
Dim sTemp() As String
Dim lCount As Long

If Len(sServices) > 0 Then
    sTemp = Split(sServices, ";")
    Set ConvertToServiceEnum = New cServiceEnum
    For lCount = 0 To UBound(sTemp)
        Set cTempService = New CService
        cTempService.Init_ m_SCM_Handle, sTemp(lCount)
        ConvertToServiceEnum.AddItem cTempService
        Set cTempService = Nothing
    Next
End If

End Function

Private Sub RaiseError(sFuncName As String, Optional APIError As CServiceErrorConstants, Optional sErrorMessage As String)
If (Len(sErrorMessage) = 0) Then
    If (Err.LastDllError <> 0) Or (APIError <> 0) Then
        sErrorMessage = "API Error"
        If (APIError = 0) Then APIError = Err.LastDllError
'            'API Error abfeuern, ausgelesen aus Err.LastDllError
'            Err.Raise Err.LastDllError, c_Class & sFuncName, PrintMSG(Err.LastDllError)
'        Else
            'vordefinierten API Error abfeuern
            Err.Raise APIError, c_Class & sFuncName, PrintMSG(APIError)
'        End If
    Else
        Err.Raise vbObjectError, c_Class & sFuncName, "Ein unbekannter Fehler ist aufgetreten!"
    End If
Else
    'Benutzerdefinierter Fehler abfeuern
    If (APIError = 0) Then
        'allgemeiner Fehler
        Err.Raise vbObjectError, c_Class & sFuncName, sErrorMessage
    Else
        'Fehler mit dedizierter Fehlernummer
        Err.Raise APIError, c_Class & sFuncName, sErrorMessage
    End If
End If
End Sub

