VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CServiceManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'************************************************************************************
'*
'*  Klassenname:    CServiceManager
'*  Beschreibung:   dient zum Administrieren und Erstellen von Services unter WinNT4 und hher
'*
'*  Autoren:        Kai Liebenau, Achim Neubauer (c)2004, 2005
'*
'*  erstellt fr:   Active VB als Erneuerung der Serviceklasse Kat 114
'*                  Erweiterrung um Funktionalitten fr Windows 2000 und hher,
'*                  also Failactions und Description
'*
'*  Version:        V 1.0
'*
'*
'*  todo:
'*
'*
'*
'************************************************************************************

'******************************************************************************'
'* API-Deklarationen                                                          *'


'Typen fr EnumServiceStatus()
'Private Type SERVICE_STATUS
'    dwServiceType As Long
'    dwCurrentState As Long
'    dwControlsAccepted As Long
'    dwWin32ExitCode As Long
'    dwServiceSpecificExitCode As Long
'    dwCheckPoint As Long
'    dwWaitHint As Long
'End Type

'Private Type ENUM_SERVICE_STATUS
'    lpServiceName As Long
'    lpDisplayName As Long
'    ServiceStatus As SERVICE_STATUS
'End Type


'******************************************************************************'
'* Interne Daten                                                              *'
Private Const c_Class As String = "CServiceManager"

Dim m_PrefetchInfos As Boolean
'Dim m_PrefetchData As ServiceInformation
Dim hDatabase As Long



'******************************************************************************'
'* ffentliche Methoden                                                       *'

Public Sub Connect(Optional ByVal sServer As String = vbNullString)
Const sFunc As String = "::Connect"

    If (hDatabase <> 0) Then
        'RaiseEvent Warning("Verbindung zur Dienste-Datenbank besteht bereits.")
        Exit Sub
    End If
    
    hDatabase = API_OpenSCManager(sServer, _
                                  vbNullString, _
                                  SC_MANAGER_CONNECT Or _
                                  SC_MANAGER_ENUMERATE_SERVICE Or _
                                  STANDARD_RIGHTS_READ Or _
                                  SC_MANAGER_CREATE_SERVICE Or _
                                  SC_MANAGER_LOCK)
    
    If (hDatabase = 0) Then Call RaiseError(sFunc)
    
End Sub

Public Sub Disconnect()
Const sFunc As String = "::Disconnect"

    If (hDatabase = 0) Then Exit Sub
    
    If API_CloseServiceHandle(hDatabase) = 0 Then Call RaiseError(sFunc)
        
    hDatabase = 0
End Sub

Public Function EnumServices(Optional ByVal ActivityState As enumServiceActivityState = SERVICE_STATE_ALL) As cServiceEnum ' ServiceInformation()
    Dim T As Long
    Dim result As Long
    
    Dim Buffer() As Byte
    
    Dim BytesNeeded As Long
    Dim StructsNeeded As Long
    Dim ServicesReturned As Long
    Dim EnumHandle As Long
    
    Dim ServiceStatus() As ENUM_SERVICE_STATUS
    Dim Services As cServiceEnum
    Dim Service As CService
    
    Const sFunc As String = "::EnumServices"

    If (Not Me.Connected) Then
        Call RaiseError(sFunc, 2, "Momentan nicht mit der Datenbank verbunden")
        Exit Function
    End If
    
    Set Services = New cServiceEnum
    
    Err.Clear
    result = API_EnumServicesStatus(hDatabase, _
                                SERVICE_WIN32, ActivityState, _
                                ByVal 0&, 0&, BytesNeeded, _
                                ServicesReturned, EnumHandle)

    If BytesNeeded = 0 Then
        Call RaiseError(sFunc)
        Exit Function
    End If
    
    ReDim Buffer(BytesNeeded - 1)
    
    EnumHandle = 0
    result = API_EnumServicesStatus(hDatabase, _
                                SERVICE_WIN32, ActivityState, _
                                Buffer(0), BytesNeeded, BytesNeeded, _
                                ServicesReturned, EnumHandle)
    
    If (result = 0) Then
        Call RaiseError(sFunc)
        Exit Function
    End If
    
    ReDim ServiceStatus(ServicesReturned - 1)
    'ReDim Services(ServicesReturned - 1)
    
    Call API_CopyMemory(ServiceStatus(0), Buffer(0), ServicesReturned * LenB(ServiceStatus(0)))
    
    For T = 0 To ServicesReturned - 1
        Set Service = New CService
        Service.Init_ hDatabase, Intern_StrFromPtr(ServiceStatus(T).lpServiceName)
        Service.DisplayName = Intern_StrFromPtr(ServiceStatus(T).lpDisplayName)
        Services.AddItem Service
        
'        Services(T).KeyName = Intern_StrFromPtr(ServiceStatus(T).lpServiceName)
'        Services(T).DisplayName = Intern_StrFromPtr(ServiceStatus(T).lpDisplayName)
'        Services(T).CurrentState = ServiceStatus(T).ServiceStatus.dwCurrentState
    Next T
    
    Set EnumServices = Services
    
End Function

Public Function GetService(ByVal KeyName As String) As CService
Dim pService As CService
Const sFunc As String = "::GetService"

If Me.Connected Then
    Set pService = New CService
    
    pService.Init_ hDatabase, KeyName
    Set GetService = pService
    
    Set pService = Nothing
Else
    Call RaiseError(sFunc, 2, "Momentan nicht mit der Datenbank verbunden")
End If

End Function
Public Function CreateNewService() As CService
Dim pService As CService
Const sFunc As String = "::CreateService"

If Me.Connected Then
    Set pService = New CService
    
    pService.Init_ hDatabase, vbNullString, True
    Set CreateNewService = pService
    
    Set pService = Nothing
Else
    Call RaiseError(sFunc, 2, "Momentan nicht mit der Datenbank verbunden")
End If
End Function

Public Sub InitServiceStart(ByVal KeyName As String)
Dim pService As CService
Const sFunc As String = "::InitServiceStart"

If Me.Connected Then
    Set pService = New CService
    
    pService.Init_ hDatabase, KeyName
    Call pService.ServiceControl(SartCtl)
    
    Set pService = Nothing
Else
    Call RaiseError(sFunc, 2, "Momentan nicht mit der Datenbank verbunden")
End If
End Sub

Public Sub InitServiceStop(ByVal KeyName As String)
Dim pService As CService
Const sFunc As String = "::InitServiceStop"

If Me.Connected Then
    Set pService = New CService
    
    pService.Init_ hDatabase, KeyName
    Call pService.ServiceControl(StopCtl)
    
    Set pService = Nothing
Else
    Call RaiseError(sFunc, 2, "Momentan nicht mit der Datenbank verbunden")
End If
End Sub


'SERVICE_START

'******************************************************************************'
'* ffentliche Eigenschaften                                                  *'

Public Property Get Connected() As Boolean
    Connected = (hDatabase <> 0)
End Property

'Public Property Get PrefetchInfos() As Boolean
'    PrefetchInfos = m_PrefetchInfos
'End Property
'
'Public Property Let PrefetchInfos(NewValue As Boolean)
'    m_PrefetchInfos = NewValue
'
'    If m_PrefetchInfos Then m_PrefetchData.KeyName = vbNullString
'End Property

Private Function Intern_StrFromPtr(ByVal lpStr As Long) As String
    Dim nSize As Long
    
    nSize = StrLenA(lpStr)
    
    If (nSize > 0) Then
        Intern_StrFromPtr = String$(nSize, vbNullChar)
        Call PtrToStrA(Intern_StrFromPtr, lpStr)
    End If
End Function

Private Sub Class_Terminate()
    If Me.Connected Then Me.Disconnect
End Sub

Private Sub RaiseError(sFuncName As String, Optional APIError As Long, Optional sErrorMessage As String)
If (Len(sErrorMessage) = 0) Then
    If (Err.LastDllError <> 0) Or (APIError <> 0) Then
        sErrorMessage = "API Error"
        If (APIError = 0) Then APIError = Err.LastDllError
            'vordefinierten API Error abfeuern
            Err.Raise APIError, c_Class & sFuncName, PrintMSG(APIError)
    Else
        Err.Raise vbObjectError, c_Class & sFuncName, "Ein unbekannter Fehler ist aufgetreten!"
    End If
Else
    'Benutzerdefinierter Fehler abfeuern
    If (APIError = 0) Then
        'allgemeiner Fehler
        Err.Raise vbObjectError, c_Class & sFuncName, sErrorMessage
    Else
        'Fehler mit dedizierter Fehlernummer
        Err.Raise APIError, c_Class & sFuncName, sErrorMessage
    End If
End If
End Sub
