VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPrivilege"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Module        : cPrivilege
' Modultyp      : Klassenmodul
' Datum         : 01.10.2005 10:14
' Autor         : Kai Liebenau (Kai@ActiveVB.de)
' Beschreibung  :
'---------------------------------------------------------------------------------------

Option Explicit

Private Declare Function GetCurrentProcess Lib "kernel32.dll" () As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long

Private Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As Luid) As Long
Private Declare Function LookupPrivilegeDisplayName Lib "advapi32.dll" Alias "LookupPrivilegeDisplayNameA" (ByVal lpSystemName As String, ByVal lpName As String, ByVal lpDisplayName As String, ByRef cbDisplayName As Long, ByRef lpLanguageID As Long) As Long
Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Private Declare Function PrivilegeCheck Lib "advapi32.dll" (ByVal TokenHandle As Long, ByRef RequiredPrivileges As PRIVILEGE_SET, ByRef pfResult As Long) As Long

Private Type Luid
   lowpart As Long
   highpart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
   pLuid As Luid
   Attributes As Long
End Type

Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(64) As LUID_AND_ATTRIBUTES
End Type

Private Type PRIVILEGE_SET
    PrivilegeCount As Long
    Control As Long
    Privileges(64) As LUID_AND_ATTRIBUTES
End Type

Public Enum ePrivileges
    SE_CREATE_TOKEN = 1 'As String = "SeCreateTokenPrivilege"
    SE_ASSIGNPRIMARYTOKEN 'As String = "SeAssignPrimaryTokenPrivilege"
    SE_LOCK_MEMORY 'As String = "SeLockMemoryPrivilege"
    SE_INCREASE_QUOTA 'As String = "SeIncreaseQuotaPrivilege"
    SE_UNSOLICITED_INPUT 'As String = "SeUnsolicitedInputPrivilege"
    SE_MACHINE_ACCOUNT 'As String = "SeMachineAccountPrivilege"
    SE_TCB 'As String = "SeTcbPrivilege"
    SE_SECURITY 'As String = "SeSecurityPrivilege"
    SE_TAKE_OWNERSHIP 'As String = "SeTakeOwnershipPrivilege"
    SE_LOAD_DRIVER 'As String = "SeLoadDriverPrivilege"
    SE_SYSTEM_PROFILE 'As String = "SeSystemProfilePrivilege"
    SE_SYSTEMTIME 'As String = "SeSystemtimePrivilege"
    SE_PROF_SINGLE_PROCESS 'As String = "SeProfileSingleProcessPrivilege"
    SE_INC_BASE_PRIORITY 'As String = "SeIncreaseBasePriorityPrivilege"
    SE_CREATE_PAGEFILE 'As String = "SeCreatePagefilePrivilege"
    SE_CREATE_PERMANENT 'As String = "SeCreatePermanentPrivilege"
    SE_BACKUP 'As String = "SeBackupPrivilege"
    SE_RESTORE 'As String = "SeRestorePrivilege"
    SE_SHUTDOWN 'As String = "SeShutdownPrivilege"
    SE_DEBUG 'As String = "SeDebugPrivilege"
    SE_AUDIT 'As String = "SeAuditPrivilege"
    SE_SYSTEM_ENVIRONMENT 'As String = "SeSystemEnvironmentPrivilege"
    SE_CHANGE_NOTIFY 'As String = "SeChangeNotifyPrivilege"
    SE_REMOTE_SHUTDOWN 'As String = "SeRemoteShutdownPrivilege"
    SE_UNDOCK 'As String = "SeUndockPrivilege"
    SE_SYNC_AGENT 'As String = "SeSyncAgentPrivilege"
    SE_ENABLE_DELEGATION 'As String = "SeEnableDelegationPrivilege"
    SE_MANAGE_VOLUME 'As String = "SeManageVolumePrivilege"
End Enum

Private Const SE_CREATE_TOKEN_NAME = "SeCreateTokenPrivilege"
Private Const SE_ASSIGNPRIMARYTOKEN_NAME = "SeAssignPrimaryTokenPrivilege"
Private Const SE_LOCK_MEMORY_NAME = "SeLockMemoryPrivilege"
Private Const SE_INCREASE_QUOTA_NAME = "SeIncreaseQuotaPrivilege"
Private Const SE_UNSOLICITED_INPUT_NAME = "SeUnsolicitedInputPrivilege"
Private Const SE_MACHINE_ACCOUNT_NAME = "SeMachineAccountPrivilege"
Private Const SE_TCB_NAME = "SeTcbPrivilege"
Private Const SE_SECURITY_NAME = "SeSecurityPrivilege"
Private Const SE_TAKE_OWNERSHIP_NAME = "SeTakeOwnershipPrivilege"
Private Const SE_LOAD_DRIVER_NAME = "SeLoadDriverPrivilege"
Private Const SE_SYSTEM_PROFILE_NAME = "SeSystemProfilePrivilege"
Private Const SE_SYSTEMTIME_NAME = "SeSystemtimePrivilege"
Private Const SE_PROF_SINGLE_PROCESS_NAME = "SeProfileSingleProcessPrivilege"
Private Const SE_INC_BASE_PRIORITY_NAME = "SeIncreaseBasePriorityPrivilege"
Private Const SE_CREATE_PAGEFILE_NAME = "SeCreatePagefilePrivilege"
Private Const SE_CREATE_PERMANENT_NAME = "SeCreatePermanentPrivilege"
Private Const SE_BACKUP_NAME = "SeBackupPrivilege"
Private Const SE_RESTORE_NAME = "SeRestorePrivilege"
Private Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"
Private Const SE_DEBUG_NAME = "SeDebugPrivilege"
Private Const SE_AUDIT_NAME = "SeAuditPrivilege"
Private Const SE_SYSTEM_ENVIRONMENT_NAME = "SeSystemEnvironmentPrivilege"
Private Const SE_CHANGE_NOTIFY_NAME = "SeChangeNotifyPrivilege"
Private Const SE_REMOTE_SHUTDOWN_NAME = "SeRemoteShutdownPrivilege"
Private Const SE_UNDOCK_NAME = "SeUndockPrivilege"
Private Const SE_SYNC_AGENT_NAME = "SeSyncAgentPrivilege"
Private Const SE_ENABLE_DELEGATION_NAME = "SeEnableDelegationPrivilege"
Private Const SE_MANAGE_VOLUME_NAME = "SeManageVolumePrivilege"

Private Const TOKEN_ADJUST_PRIVILEGES = &H20
Private Const TOKEN_QUERY = &H8


Private Function EnumPrivileges(lPriv As ePrivileges) As String
Select Case lPriv
    Case SE_CREATE_TOKEN: EnumPrivileges = SE_CREATE_TOKEN_NAME
    Case SE_ASSIGNPRIMARYTOKEN: EnumPrivileges = SE_ASSIGNPRIMARYTOKEN_NAME
    Case SE_LOCK_MEMORY: EnumPrivileges = SE_LOCK_MEMORY_NAME
    Case SE_INCREASE_QUOTA: EnumPrivileges = SE_INCREASE_QUOTA_NAME
    Case SE_UNSOLICITED_INPUT: EnumPrivileges = SE_UNSOLICITED_INPUT_NAME
    Case SE_MACHINE_ACCOUNT: EnumPrivileges = SE_MACHINE_ACCOUNT_NAME
    Case SE_TCB: EnumPrivileges = SE_TCB_NAME
    Case SE_SECURITY: EnumPrivileges = SE_SECURITY_NAME
    Case SE_TAKE_OWNERSHIP: EnumPrivileges = SE_TAKE_OWNERSHIP_NAME
    Case SE_LOAD_DRIVER: EnumPrivileges = SE_LOAD_DRIVER_NAME
    Case SE_SYSTEM_PROFILE: EnumPrivileges = "SeSystemProfilePrivilege"
    Case SE_SYSTEMTIME: EnumPrivileges = SE_SYSTEMTIME_NAME
    Case SE_PROF_SINGLE_PROCESS: EnumPrivileges = SE_PROF_SINGLE_PROCESS_NAME
    Case SE_INC_BASE_PRIORITY: EnumPrivileges = SE_INC_BASE_PRIORITY_NAME
    Case SE_CREATE_PAGEFILE: EnumPrivileges = SE_CREATE_PAGEFILE_NAME
    Case SE_CREATE_PERMANENT: EnumPrivileges = SE_CREATE_PERMANENT_NAME
    Case SE_BACKUP: EnumPrivileges = SE_BACKUP_NAME
    Case SE_RESTORE: EnumPrivileges = SE_RESTORE_NAME
    Case SE_SHUTDOWN: EnumPrivileges = SE_SHUTDOWN_NAME
    Case SE_DEBUG: EnumPrivileges = SE_DEBUG_NAME
    Case SE_AUDIT: EnumPrivileges = SE_AUDIT_NAME
    Case SE_SYSTEM_ENVIRONMENT: EnumPrivileges = SE_SYSTEM_ENVIRONMENT_NAME
    Case SE_CHANGE_NOTIFY: EnumPrivileges = SE_CHANGE_NOTIFY_NAME
    Case SE_REMOTE_SHUTDOWN: EnumPrivileges = SE_REMOTE_SHUTDOWN_NAME
    Case SE_UNDOCK: EnumPrivileges = SE_UNDOCK_NAME
    Case SE_SYNC_AGENT: EnumPrivileges = SE_SYNC_AGENT_NAME
    Case SE_ENABLE_DELEGATION: EnumPrivileges = SE_ENABLE_DELEGATION_NAME
    Case SE_MANAGE_VOLUME: EnumPrivileges = SE_MANAGE_VOLUME_NAME
End Select
End Function
'******************************************************************************
' [Function] AdjustTokenPriv()Long
' [In] Privileg As ePrivileges (bsp: SE_TCB_NAME)
' [OPTIONAL,IN] bOnOff As Boolean {TRUE(Priv enable)/FALSE(Priv disable)}
' [RETVAL]: Long -> ErrNumber oder ERROR_SUCCESS, 5 Privileg nicht im Token !!!
'******************************************************************************
Public Function AdjustTokenPriv(Privileg As ePrivileges, Optional bOnOff As Boolean = False) As Long
On Error GoTo ErrorHandler
    
Dim hTokenHandle As Long
Dim lRet As Long
Dim uLUID As Luid
Dim uTokenPrivNew As TOKEN_PRIVILEGES
Dim uTokenPrivOld As TOKEN_PRIVILEGES
Dim lBufferLength As Long

If Len(EnumPrivileges(Privileg)) = 0 Then AdjustTokenPriv = 87: Exit Function

If OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, hTokenHandle) Then
    If LookupPrivilegeValue(vbNullString, EnumPrivileges(Privileg), uLUID) Then
        With uTokenPrivNew
            .PrivilegeCount = 1
            .Privileges(0).Attributes = IIf(bOnOff, 2, 0)
            .Privileges(0).pLuid = uLUID
        End With
        
        If AdjustTokenPrivileges(hTokenHandle, False, uTokenPrivNew, Len(uTokenPrivOld), uTokenPrivOld, lBufferLength) = 0 Then
            lRet = Err.LastDllError
        ElseIf uTokenPrivOld.PrivilegeCount = 0 Then
            'Privileg nicht im Token enthalten
            lRet = 5
        End If
    Else
        lRet = Err.LastDllError
    End If
    Call CloseHandle(hTokenHandle)
Else
    lRet = Err.LastDllError
End If
AdjustTokenPriv = lRet
Exit Function
ErrorHandler:
AdjustTokenPriv = vbObjectError
End Function

'******************************************************************************
' [Function] IsPrivilegEnabled()Long
' [IN]: Privileg As ePrivileges
' [RETVAL]: Long -> 0 Disabled
'                   1 Enabled
'                   Errornumber
'******************************************************************************
Public Function IsPrivilegEnabled(ByVal Privileg As ePrivileges) As Long
On Error GoTo ErrorHandler
    
Dim hTokenHandle As Long
Dim lRet As Long
Dim pResult As Long
Dim uLUID As Luid
Dim uTokenPrivQuery As PRIVILEGE_SET

If Len(EnumPrivileges(Privileg)) = 0 Then IsPrivilegEnabled = 87: Exit Function

If OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY, hTokenHandle) Then
    If LookupPrivilegeValue(vbNullString, EnumPrivileges(Privileg), uLUID) Then
        With uTokenPrivQuery
            .PrivilegeCount = 1
            .Privileges(0).pLuid = uLUID
        End With
        
        If PrivilegeCheck(hTokenHandle, uTokenPrivQuery, pResult) = 0 Then
            lRet = Err.LastDllError
        Else
            lRet = pResult
        End If
    Else
        lRet = Err.LastDllError
    End If
    Call CloseHandle(hTokenHandle)
Else
    lRet = Err.LastDllError
End If
IsPrivilegEnabled = lRet
Exit Function
ErrorHandler:
IsPrivilegEnabled = vbObjectError
End Function

Property Get DisplayName(Privileg As ePrivileges) As String
Dim lRet As Long
Dim sTemp As String
Dim lSize As Long

If Len(EnumPrivileges(Privileg)) = 0 Then Exit Property

lRet = LookupPrivilegeDisplayName(vbNullString, EnumPrivileges(Privileg), vbNullString, lSize, 407)
If lSize Then
    sTemp = String$(lSize, 0)
    lRet = LookupPrivilegeDisplayName(vbNullString, EnumPrivileges(Privileg), sTemp, lSize, 407)
    DisplayName = Left$(sTemp, Len(sTemp) - 1)
End If
End Property
