Attribute VB_Name = "modMain"
Option Explicit

Public Type SERVICE_STATUS
    dwServiceType As Long
    dwCurrentState As Long
    dwControlsAccepted As Long
    dwWin32ExitCode As Long
    dwServiceSpecificExitCode As Long
    dwCheckPoint As Long
    dwWaitHint As Long
End Type

Public Type ENUM_SERVICE_STATUS
    lpServiceName As Long
    lpDisplayName As Long
    ServiceStatus As SERVICE_STATUS
End Type

Public Enum enumServiceQuery2
    SERVICE_CONFIG_DESCRIPTION = 1
    SERVICE_CONFIG_FAILURE_ACTIONS = 2
End Enum

'Kernel APIs
Public Declare Function API_LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" ( _
     ByVal LibFileName As String) As Long

Public Declare Function API_GetProcAddress Lib "kernel32.dll" Alias "GetProcAddress" ( _
     ByVal hlibModule As Long, _
     ByVal ProcName As String) As Long

Public Declare Function API_FreeLibrary Lib "kernel32.dll" Alias "FreeLibrary" ( _
     ByVal hlibModule As Long) As Long

Public Declare Sub API_CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
     ByRef Destination As Any, _
     ByRef Source As Any, _
     ByVal Length As Long)


'String(Kernel32) APIs
Public Declare Function StrLenA Lib "kernel32.dll" Alias "lstrlenA" ( _
     ByVal Pointer As Long) As Long

Public Declare Function StrLenW Lib "kernel32.dll" Alias "lstrlenW" ( _
     ByVal Pointer As Long) As Long

Public Declare Function PtrToStrA Lib "kernel32.dll" Alias "lstrcpyA" ( _
     ByVal DestinationString As String, _
     ByVal SourcePointer As Long) As Long

Public Declare Function PtrToStrW Lib "kernel32.dll" Alias "lstrcpyW" ( _
     ByVal DestinationPointer As Long, _
     ByVal SourcePointer As Long) As Long

'Service APIs
Public Declare Function API_OpenService Lib "advapi32.dll" Alias "OpenServiceA" ( _
     ByVal hSCManager As Long, _
     ByVal ServiceName As String, _
     ByVal dwDesiredAccess As Long) As Long

Public Declare Function API_QueryServiceConfig Lib "advapi32.dll" Alias "QueryServiceConfigW" ( _
     ByVal hService As Long, _
     ByRef ServiceConfig As Any, _
     ByVal cbBufSize As Long, _
     ByRef BytesNeeded As Long) As Long

Public Declare Function API_QueryServiceStatus Lib "advapi32.dll" Alias "QueryServiceStatus" ( _
     ByVal hService As Long, _
     ByRef lpServiceStatus As SERVICE_STATUS) As Long

Public Declare Function API_ChangeServiceConfig Lib "advapi32.dll" Alias "ChangeServiceConfigA" ( _
     ByVal hService As Long, _
     ByVal dwServiceType As Long, _
     ByVal dwStartType As Long, _
     ByVal dwErrorControl As Long, _
     ByVal lpBinaryPathName As String, _
     ByVal lpLoadOrderGroup As String, _
     ByVal lpdwTagId As Long, _
     ByVal lpDependencies As String, _
     ByVal lpServiceStartName As String, _
     ByVal lpPassword As String, _
     ByVal lpDisplayName As String) As Long

Public Declare Function API_CreateService Lib "advapi32.dll" Alias "CreateServiceA" ( _
     ByVal hSCManager As Long, _
     ByVal lpServiceName As String, _
     ByVal lpDisplayName As String, _
     ByVal dwDesiredAccess As Long, _
     ByVal dwServiceType As Long, _
     ByVal dwStartType As Long, _
     ByVal dwErrorControl As Long, _
     ByVal lpBinaryPathName As String, _
     ByVal lpLoadOrderGroup As String, _
     ByRef lpdwTagId As Long, _
     ByVal lpDependencies As String, _
     ByVal lpStartName As String, _
     ByVal lpPassword As String) As Long


Public Declare Function API_GetServiceDisplayName Lib "advapi32.dll" Alias "GetServiceDisplayNameA" ( _
     ByVal hSCManager As Long, _
     ByVal lpServiceName As String, _
     ByRef lpDisplayName As Any, _
     ByRef lpcchBuffer As Long) As Long

Public Declare Function API_StartService Lib "advapi32.dll" Alias "StartServiceA" ( _
     ByVal hService As Long, _
     ByVal dwNumServiceArgs As Long, _
     ByRef lpServiceArgVectors As Any) As Long

Public Declare Function API_ControlService Lib "advapi32.dll" Alias "ControlService" ( _
     ByVal hService As Long, _
     ByVal dwControl As enum_Service_Control, _
     ByRef lpServiceStatus As SERVICE_STATUS) As Long

Public Declare Function API_QueryServiceConfig2 Lib "advapi32.dll" Alias "QueryServiceConfig2W" ( _
     ByVal hService As Long, _
     ByVal dwInfoLevel As enumServiceQuery2, _
     ByRef lpBuffer As Any, _
     ByVal cbBufSize As Long, _
     ByRef pcbBytesNeeded As Long) As Long
     
Public Declare Function API_ChangeServiceConfig2 Lib "advapi32.dll" Alias "ChangeServiceConfig2W" ( _
     ByVal hService As Long, _
     ByVal dwInfoLevel As Long, _
     ByRef lpInfo As Any) As Long

Public Declare Function API_LockServiceDatabase Lib "advapi32.dll" Alias "LockServiceDatabase" ( _
     ByVal hSCManager As Long) As Long

Public Declare Function API_UnlockServiceDatabase Lib "advapi32.dll" Alias "UnlockServiceDatabase" ( _
     ByVal hLockHandle As Long) As Long

Public Declare Function API_CloseServiceHandle Lib "advapi32.dll" Alias "CloseServiceHandle" ( _
     ByVal hSCObject As Long) As Long

Public Declare Function GetLastError Lib "kernel32.dll" () As Long

Public Declare Function API_OpenSCManager Lib "advapi32.dll" Alias "OpenSCManagerA" ( _
     ByVal lpMachineName As String, _
     ByVal lpDatabaseName As String, _
     ByVal dwDesiredAccess As Long) As Long

'
Public Declare Function API_EnumServicesStatus Lib "advapi32.dll" Alias "EnumServicesStatusA" ( _
     ByVal hSCManager As Long, _
     ByVal dwServiceType As Long, _
     ByVal dwServiceState As Long, _
     ByRef lpServices As Any, _
     ByVal cbBufSize As Long, _
     ByRef pcbBytesNeeded As Long, _
     ByRef lpServicesReturned As Long, _
     ByRef lpResumeHandle As Long) As Long

Public Declare Function API_EnumDependentServices Lib "advapi32.dll" Alias "EnumDependentServicesA" ( _
     ByVal hService As Long, _
     ByVal dwServiceState As Long, _
     ByRef lpServices As Any, _
     ByVal cbBufSize As Long, _
     ByRef pcbBytesNeeded As Long, _
     ByRef lpServicesReturned As Long) As Long

Public Declare Function API_FormatMessage Lib "kernel32" Alias "FormatMessageA" ( _
     ByVal dwFlags As Long, _
     ByRef lpSource As Any, _
     ByVal dwMessageId As Long, _
     ByVal dwLanguageId As Long, _
     ByVal lpBuffer As String, _
     ByVal nSize As Long, _
     ByRef Arguments As Long) As Long

Public Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)

Public Const SERVICE_FAIL_COUNTER              As String = "/fail=%1%"
Public Const BLANK_CHAR                        As String = " "
Public Const ERROR_SERVICE_SPECIFIC As String = "Der Dienst ""%DISPLAYNAME%"" wurde mit folgendem dienstspezifischem Fehler beendet: "

Public Enum enum_Service_Control
    SERVICE_CONTROL_STOP = &H1&
    SERVICE_CONTROL_CONTINUE = &H3&
    SERVICE_CONTROL_PAUSE = &H2&
    SERVICE_CONTROL_SHUTDOWN = &H5&
End Enum

Public Const SERVICE_WIN32_OWN_PROCESS As Long = 16&
Public Const SERVICE_WIN32_SHARE_PROCESS As Long = 32&
Public Const SERVICE_WIN32 As Long = (SERVICE_WIN32_OWN_PROCESS Or SERVICE_WIN32_SHARE_PROCESS)



'Accessrights auf einen Service
Public Const READ_CONTROL As Long = &H20000
Public Const STANDARD_RIGHTS_READ As Long = (READ_CONTROL)
Public Const STANDARD_RIGHTS_REQUIRED          As Long = &HF0000
Public Const SERVICE_QUERY_CONFIG              As Long = &H1
Public Const SERVICE_CHANGE_CONFIG             As Long = &H2
Public Const SERVICE_QUERY_STATUS              As Long = &H4
Public Const SERVICE_ENUMERATE_DEPENDENTS      As Long = &H8
Public Const SERVICE_START                     As Long = &H10
Public Const SERVICE_STOP                      As Long = &H20
Public Const SERVICE_PAUSE_CONTINUE            As Long = &H40
Public Const SERVICE_INTERROGATE               As Long = &H80
Public Const SERVICE_USER_DEFINED_CONTROL      As Long = &H100

Public Const SERVICE_CONTROL                       As Long = SERVICE_START Or _
                                                              SERVICE_STOP Or _
                                                              SERVICE_PAUSE_CONTINUE Or _
                                                              SERVICE_INTERROGATE
'SYSTEM hat die gleichen Rechte wie:
Public Const SERVICE_RIGHTS_POWER_USERS            As Long = SERVICE_QUERY_CONFIG Or _
                                                              SERVICE_QUERY_STATUS Or _
                                                              SERVICE_ENUMERATE_DEPENDENTS Or _
                                                              SERVICE_CONTROL Or _
                                                              SERVICE_USER_DEFINED_CONTROL Or _
                                                              READ_CONTROL
                                                          
Public Const SERVICE_RIGHTS_AUTHENTICATED_USERS    As Long = SERVICE_QUERY_CONFIG Or _
                                                              SERVICE_QUERY_STATUS Or _
                                                              SERVICE_ENUMERATE_DEPENDENTS Or _
                                                              SERVICE_INTERROGATE Or _
                                                              SERVICE_USER_DEFINED_CONTROL Or _
                                                              READ_CONTROL
                                                          
Public Const SERVICE_ALL_ACCESS                As Long = (STANDARD_RIGHTS_REQUIRED Or _
                                                           SERVICE_QUERY_CONFIG Or _
                                                           SERVICE_CHANGE_CONFIG Or _
                                                           SERVICE_QUERY_STATUS Or _
                                                           SERVICE_ENUMERATE_DEPENDENTS Or _
                                                           SERVICE_START Or _
                                                           SERVICE_STOP Or _
                                                           SERVICE_PAUSE_CONTINUE Or _
                                                           SERVICE_INTERROGATE Or _
                                                           SERVICE_USER_DEFINED_CONTROL)

'Private Const SERVICE_RIGHTS_ADMINISTRATORS         As Long = SERVICE_ALL_ACCESS

'SC Manage Konst
Public Const SC_MANAGER_CONNECT As Long = 1&
Public Const SC_MANAGER_CREATE_SERVICE As Long = &H2&
Public Const SC_MANAGER_ENUMERATE_SERVICE As Long = 4&
Public Const SC_MANAGER_LOCK As Long = &H8

Sub Main()
'Dummy
End Sub

Public Function PrintMSG(ErrNR As Long) As String
Dim lRetLength  As Long
Dim sMessage    As String
'Buffer init
sMessage = Space$(2000)
'ErrorMessage holen
lRetLength = API_FormatMessage(&H1000, ByVal 0&, ErrNR, 0&, sMessage, Len(sMessage), ByVal 0&)
'ErrorMessage zurechtschneiden
PrintMSG = Left$(sMessage, lRetLength)
End Function

Public Function EleminateGroups(sDeps As String) As String
Dim sArr() As String
Dim x As Long

sArr = Split(sDeps, ";")

For x = 0 To UBound(sArr)
    'Gruppen werden gelscht
    If Left$(sArr(x), 1) = "+" Then sArr(x) = vbNullString
Next

EleminateGroups = Join(sArr, ";")

Do While InStr(1, EleminateGroups, ";;")
    EleminateGroups = Replace$(EleminateGroups, ";;", ";")
Loop

If Right$(EleminateGroups, 1) = ";" Then _
    EleminateGroups = Left$(EleminateGroups, Len(EleminateGroups) - 1)
End Function

